#include <math.h>
#include "CalcCoordinate.h"
#include <QDebug>

#define ZERO           (0.000001)
#define PI             float(3.14159265358979323846)

/*************************************************
:		// CalcU
:		// 2㷨궨SCARAûϵ
:		// ָͬһ̬
:		//  1궨󣬴ͬ
                0궨ɹ
Ӻ:		// 
*************************************************/

int CalcU(pstScaraPose PointOrigin, pstScaraPose PointX, pstScaraPose UserCoordinateAxis)
{
    float theta = 0.0;

    theta = atan2(PointX->y - PointOrigin->y, PointX->x - PointOrigin->x);

    UserCoordinateAxis->x = PointOrigin->x;
    UserCoordinateAxis->y = PointOrigin->y;
    UserCoordinateAxis->z = PointOrigin->z;
    UserCoordinateAxis->r = float(theta * 180 / PI);

    qDebug() << "****************CalcU********************\n"
             << "PointOrigin" << PointOrigin->x << PointOrigin->y << PointOrigin->z << PointOrigin->r << "\n"
             << "PointX" << PointX->x << PointX->y << PointX->z << PointX->r << "\n"
             << "UserCoordinateAxis" << UserCoordinateAxis->x << UserCoordinateAxis->y << UserCoordinateAxis->z << UserCoordinateAxis->r << "\n";
    return 0;
}



/*************************************************
:		// CalcT
:		// 2㷨궨SCARA˹λ
:		// ָͬһ̬
:		//  1궨󣬴ͬ
                0궨ɹ
Ӻ:		// 
*************************************************/
int CalcT(pstScaraPose Pose1, pstScaraPose Pose2, pstScaraPose ToolPose)
{
    float X1 = Pose1->x;
    float Y1 = Pose1->y;
    float R1 = float(Pose1->r * PI / 180);
    float X2 = Pose2->x;
    float Y2 = Pose2->y;
    float R2 = float(Pose2->r * PI / 180);

    float a = cos(R1) - cos(R2);
    float b = sin(R1) - sin(R2);
    if (fabs(a) < ZERO && fabs(b) < ZERO)
    {
        return 1;                             // 궨
    }
    ToolPose->y = (a*(Y2-Y1) - b*(X2-X1)) / (a*a + b*b);
    ToolPose->x = (a*(X2-X1) + b*(Y2-Y1)) / (a*a + b*b);
    ToolPose->z = 0;
    ToolPose->r = 0;

    qDebug() << "****************CalcT********************\n"
             << "Pose1" << Pose1->x << Pose1->y << Pose1->z << Pose1->r << "\n"
             << "Pose2" << Pose2->x << Pose2->y << Pose2->z << Pose2->r << "\n"
             << "ToolPose" << ToolPose->x << ToolPose->y << ToolPose->z << ToolPose->r << "\n";
    return 0;
}
