﻿        /****************************************Copyright(c)*****************************************************
    **                            Shenzhen Yuejiang Technology Co., LTD.
    **
    **                                 http://www.dobot.cc
    **
    **--------------File Info---------------------------------------------------------------------------------
    ** File name:           ProtocolID.h
    ** Latest modified Date:2016-08-17
    ** Latest Version:      V1.2.0
    ** Descriptions:        Protocol ID definition
    **
    **--------------------------------------------------------------------------------------------------------
    ** Created by:          Liu Zhufu
    ** Created date:        2016-03-15
    ** Version:             V1.0.0
    ** Descriptions:
    **--------------------------------------------------------------------------------------------------------
    *********************************************************************************************************/
    #ifndef PROTOCOLID_H
    #define PROTOCOLID_H

    typedef enum {
        // Device information
        ProtocolFunctionDeviceInfoBase      = 0,
        ProtocolDeviceSN                    = ProtocolFunctionDeviceInfoBase + 0,
        ProtocolDeviceName                  = ProtocolFunctionDeviceInfoBase + 1,
        ProtocolDeviceVersion               = ProtocolFunctionDeviceInfoBase + 2,
        ProtocolDeviceWithL                 = ProtocolFunctionDeviceInfoBase + 3,
        ProtocolDeviceTime                  = ProtocolFunctionDeviceInfoBase + 4,
        ProtocolHardwareVersion             = ProtocolFunctionDeviceInfoBase + 5,

        // Pose
        ProtocolFunctionPoseBase            = 10,
        ProtocolGetPose                     = ProtocolFunctionPoseBase + 0,
        ProtocolResetPose                   = ProtocolFunctionPoseBase + 1,
        ProtocolGetKinematics               = ProtocolFunctionPoseBase + 2,
        ProtocolGetPoseL                    = ProtocolFunctionPoseBase + 3,

        // Alarm
        ProtocolFunctionALARMBase           = 20,
        ProtocolAlarmsState                 = ProtocolFunctionALARMBase + 0,
        ProtocolClearServoAlarms            = ProtocolFunctionALARMBase + 1,
        ProtocolRelieveEmergencyStop        = ProtocolFunctionALARMBase + 2,

        // HOME
        ProtocolFunctionHOMEBase            = 30,
        ProtocolHOMEParams                  = ProtocolFunctionHOMEBase + 0,
        ProtocolHOMECmd                     = ProtocolFunctionHOMEBase + 1,
        ProtocolAutoLeveling                = ProtocolFunctionHOMEBase + 2,
        ProtocolHOMEWithSwitch              = ProtocolFunctionHOMEBase + 3,

        // HHT
        ProtocolFunctionHHTBase             = 40,
        ProtocolHHTTrigMode                 = ProtocolFunctionHHTBase + 0,
        ProtocolHHTTrigOutputEnabled        = ProtocolFunctionHHTBase + 1,
        ProtocolHHTTrigOutput               = ProtocolFunctionHHTBase + 2,

        // Function-Arm Orientation
        ProtocolFunctionArmOrientationBase  = 50,
        ProtocolArmOrientation              = ProtocolFunctionArmOrientationBase + 0,
        ProtocolTransition                  = ProtocolFunctionArmOrientationBase + 1,

        // End effector
        ProtocolFunctionEndEffectorBase     = 60,
        ProtocolEndEffectorParams           = ProtocolFunctionEndEffectorBase + 0,
        ProtocolEndEffectorLaser            = ProtocolFunctionEndEffectorBase + 1,
        ProtocolEndEffectorSuctionCup       = ProtocolFunctionEndEffectorBase + 2,
        ProtocolEndEffectorGripper          = ProtocolFunctionEndEffectorBase + 3,

        // Function-JOG
        ProtocolFunctionJOGBase             = 70,
        ProtocolJOGJointParams              = ProtocolFunctionJOGBase + 0,
        ProtocolJOGCoordinateParams         = ProtocolFunctionJOGBase + 1,
        ProtocolJOGCommonParams             = ProtocolFunctionJOGBase + 2,
        ProtocolJOGCmd                      = ProtocolFunctionJOGBase + 3,
        ProtocolJOGLParams                  = ProtocolFunctionJOGBase + 4,

        // Function-PTP
        ProtocolFunctionPTPBase             = 80,
        ProtocolPTPJointParams              = ProtocolFunctionPTPBase + 0,
        ProtocolPTPCoordinateParams         = ProtocolFunctionPTPBase + 1,
        ProtocolPTPJumpParams               = ProtocolFunctionPTPBase + 2,
        ProtocolPTPCommonParams             = ProtocolFunctionPTPBase + 3,
        ProtocolPTPCmd                      = ProtocolFunctionPTPBase + 4,
        ProtocolPTPLParams                  = ProtocolFunctionPTPBase + 5,
        ProtocolPTPWithLCmd                 = ProtocolFunctionPTPBase + 6,
        ProtocolPTPJump2Params              = ProtocolFunctionPTPBase + 7,
        ProtocolPTPPOCmd                    = ProtocolFunctionPTPBase + 8,
        ProtocolPTPPOWithLCmd               = ProtocolFunctionPTPBase + 9,

        // Function-CP
        ProtocolFunctionCPBase              = 90,
        ProtocolCPParams                    = ProtocolFunctionCPBase + 0,
        ProtocolCPCmd                       = ProtocolFunctionCPBase + 1,
        ProtocolCPLECmd                     = ProtocolFunctionCPBase + 2,

        // Function-ARC
        ProtocolFunctionARCBase             = 100,
        ProtocolARCParams                   = ProtocolFunctionARCBase + 0,
        ProtocolARCCmd                      = ProtocolFunctionARCBase + 1,
        ProtocolCircleCmd                   = ProtocolFunctionARCBase + 2,

        // Function-WAIT
        ProtocolFunctionWAITBase            = 110,
        ProtocolWAITCmd                     = ProtocolFunctionWAITBase + 0,

        // Function-TRIG
        ProtocolFunctionTRIGBase            = 120,
        ProtocolTRIGCmd                     = ProtocolFunctionTRIGBase + 0,

        // Function-EIO
        ProtocolFunctionEIOBase             = 130,
        ProtocolIOMultiplexing              = ProtocolFunctionEIOBase + 0,
        ProtocolIODO                        = ProtocolFunctionEIOBase + 1,
        ProtocolIODAC                       = ProtocolFunctionEIOBase + 2,
        ProtocolIODI                        = ProtocolFunctionEIOBase + 3,
        ProtocolIOADC                       = ProtocolFunctionEIOBase + 4,
        ProtocolEMotor                      = ProtocolFunctionEIOBase + 5,
        ProtocolIODOEx                      = ProtocolFunctionEIOBase + 6,
        ProtocolIODIEx                      = ProtocolFunctionEIOBase + 7,
        ProtocolIOADCEx                     = ProtocolFunctionEIOBase + 8,
        ProtocolIODACEx                     = ProtocolFunctionEIOBase + 9,

        // Function-CAL
        ProtocolFunctionCALBase             = 140,
        ProtocolAngleSensorStaticError      = ProtocolFunctionCALBase + 0,
        ProtocolAngleSensorCoef             = ProtocolFunctionCALBase + 1,
        ProtocolBaseDecoderStaticError      = ProtocolFunctionCALBase + 2,
        ProtocolLRHandCalibrateValue        = ProtocolFunctionCALBase + 3,

        // Function-WIFI
        ProtocolFunctionWIFIBase            = 150,
        ProtocolWIFIConfig                  = ProtocolFunctionWIFIBase + 0,
        ProtocolWIFIList                    = ProtocolFunctionWIFIBase + 1,
        ProtocolWIFIStatus                  = ProtocolFunctionWIFIBase + 2,

        // Function-Firmware
        ProtocolFunctionFirmware            = 160,
        ProtocolFirmwareUpgrade             = ProtocolFunctionFirmware + 0,
        ProtocolFirmwareMode                = ProtocolFunctionFirmware + 1,
        ProtocolFirmwareUpgradeProgress     = ProtocolFunctionFirmware + 2,
        ProtocolFirmwareSelfChecking        = ProtocolFunctionFirmware + 3,
        ProtocolFirmwareTeachPendant        = ProtocolFunctionFirmware + 4,
        ProtocolFirmwareNotifyM4Mode        = ProtocolFunctionFirmware + 5,
        ProtocolFirmwareReboot              = ProtocolFunctionFirmware + 6,
        ProtocolFirmwareLanConfig           = ProtocolFunctionFirmware + 7,

        ProtocolFunctionMTBase              = 170,
        ProtocolMTEnter                     = ProtocolFunctionMTBase + 0 ,
        ProtocolMTHearBeat                  = ProtocolFunctionMTBase + 1 ,
        ProtocolMTIOInternal                = ProtocolFunctionMTBase + 2 ,   //IOOUT<-->IOINPUT connect test
        ProtocolMTIOExternal                = ProtocolFunctionMTBase + 3 ,
        ProtocolMTIOOnOff                   = ProtocolFunctionMTBase + 4 ,
        ProtocolMTCanCom                    = ProtocolFunctionMTBase + 5 ,   //can communication test
        ProtocolMT485Com                    = ProtocolFunctionMTBase + 6 ,   //485 communication test
        ProtocolMTETHCom                    = ProtocolFunctionMTBase + 7 ,   //ETH communication test
        ProtocolMTI2SCom                    = ProtocolFunctionMTBase + 8 ,   //I2S communication test
        ProtocolMTSDIOCom                   = ProtocolFunctionMTBase + 9 ,   //SDIO communication test
        ProtocolMTCoderRead                 = ProtocolFunctionMTBase + 10,
        ProtocolMTTempRead                  = ProtocolFunctionMTBase + 11,
        ProtocolMTCanAddrRead               = ProtocolFunctionMTBase + 12,   //can address encoder read
        ProtocolMTADCRead                   = ProtocolFunctionMTBase + 13,
        ProtocolMTDACRead                   = ProtocolFunctionMTBase + 14,
        ProtocolMTDACADCCon                 = ProtocolFunctionMTBase + 15,   //DAC<-->ADC connect test
        ProtocolMTTxRxCon                   = ProtocolFunctionMTBase + 16,   //RX<-->TX connect test
        ProtocolMTVGAOut                    = ProtocolFunctionMTBase + 17,
        ProtocolMTMotor                     = ProtocolFunctionMTBase + 18,
        ProtocolMTTotal                     = ProtocolFunctionMTBase + 19,   //PCBA total test
        ProtocolMTUSB                       = ProtocolFunctionMTBase + 20,   //USB
        ProtocolMTOTG                       = ProtocolFunctionMTBase + 21,   //OTG
        ProtocolMTFLASH                     = ProtocolFunctionMTBase + 22,   //Flash
        ProtocolMTSPI                       = ProtocolFunctionMTBase + 23,   //SPI
        ProtocolMTUART                      = ProtocolFunctionMTBase + 24,   //UART
        ProtocolMTDRIVER                    = ProtocolFunctionMTBase + 25,   //DRIVER
        ProtocolMTLimitSwitch               = ProtocolFunctionMTBase + 26,

        // Function-TEST
        ProtocolTESTBase                    = 220,
        ProtocolUserParams                  = ProtocolTESTBase + 0,
        ProtocolPTPTime                     = ProtocolTESTBase + 1,
        ProtocolServoPIDParams              = ProtocolTESTBase + 2,
        ProtocolServoControlLoop            = ProtocolTESTBase + 3,
        ProtocolSaveServoPIDParams          = ProtocolTESTBase + 4,
        ProtocolServoTuning                 = ProtocolTESTBase + 5,
        ProtocolSuperTest                   = ProtocolTESTBase + 6,

        // Function-QueuedCmd
        ProtocolFunctionQueuedCmdBase       = 240,
        ProtocolQueuedCmdStartExec          = ProtocolFunctionQueuedCmdBase + 0,
        ProtocolQueuedCmdStopExec           = ProtocolFunctionQueuedCmdBase + 1,
        ProtocolQueuedCmdForceStopExec      = ProtocolFunctionQueuedCmdBase + 2,
        ProtocolQueuedCmdStartDownload      = ProtocolFunctionQueuedCmdBase + 3,
        ProtocolQueuedCmdStopDownload       = ProtocolFunctionQueuedCmdBase + 4,
        ProtocolQueuedCmdClear              = ProtocolFunctionQueuedCmdBase + 5,
        ProtocolQueuedCmdCurrentIndex       = ProtocolFunctionQueuedCmdBase + 6,
        ProtocolQueuedCmdLeftSpace          = ProtocolFunctionQueuedCmdBase + 7,

        // Coordinate
        ProtocolFunctionCoordinateBase      = 250,
        ProtocolLocalParams                 = ProtocolFunctionCoordinateBase + 0,
        ProtocolToolParams                  = ProtocolFunctionCoordinateBase + 1,
        ProtocolUserAndToolParams           = ProtocolFunctionCoordinateBase + 2,

        ProtocolMax = 256
    } ProtocolID;

    #endif
